var agingTabs = {
	prefs : Components.classes['@mozilla.org/preferences-service;1']
		.getService(Components.interfaces.nsIPrefService)
		.getBranch('browser.tabs.'),
	trigger : -1,
	lastSelected : null,
	init : function() {
		this.tabContainer = gBrowser.tabContainer;
		this.prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
		for (let i=0, ss = document.styleSheets; i < ss.length; i++) {
			switch (ss[i].href) {
				case 'chrome://aging-tabs/skin/browser-default.css':
					this.defaultStyleSheet = ss[i];
					break;
				case 'chrome://aging-tabs/skin/browser-highlight.css':
					this.highlightStyleSheet = ss[i];
			}
			if (this.defaultStyleSheet && this.highlightStyleSheet)
				break;
		}
		this.getAmountPref();
		this.getDelayPref();
		this.getColorPref();
		this.getTextColorPref();
		this.getTargetColorPref();
		this.getHighlightActiveTabPref();
		this.getHighlightColorPref();
		this.getHighlightTextColorPref();
		this.prefs.addObserver('', this, false);
		window.setTimeout (function(obj) {
			obj.lastSelected = obj.tabContainer.selectedItem;
			obj.getTriggerPref();
		}, 500, this);
		let (obj = this) window.addEventListener('unload', function() {
			obj.prefs = null;
		}, false);
	},
	tabSwitch : function(age) {
		if (this.timeout)
			window.clearTimeout (this.timeout);
		this.timeout = window.setTimeout (age ?
			function(obj) { obj.step() } :
			function(obj) { obj.resetTab(obj.tabContainer.selectedItem) }, this.delay, this);
	},
	step : function() {
		var	tabs = this.tabContainer.childNodes,
			newSelected = this.lastSelected;
		for (let i=0; i < tabs.length; i++) {
			let rgb;
			if (tabs[i].selected) {
				newSelected = tabs[i];
				this.resetTab (newSelected);
				continue;
			} else if (tabs[i] == this.lastSelected)
				continue;
			let (tabStyle = getComputedStyle (tabs[i].boxObject.firstChild,'')) {
				rgb = tabStyle.getPropertyValue('background-color').match(/^rgb\((\d+), (\d+), (\d+)/);
				if (rgb == null) // that's odd
					continue;
				rgb.shift();
				if (this.targetColors.length == 0) {
					let rgbText = tabStyle.getPropertyValue('color').match(/^rgb\((\d+), (\d+), (\d+)/);
					this.targetColors.push ([
						rgbText[j] < 127 ? Math.min (255, +rgbText[j] + 150) : Math.max (0, rgbText[j] - 150)
						for each (j in [1,2,3])
					]);
				}
			}
			if (tabs[i]._agingTargetColor === undefined)
				tabs[i]._agingTargetColor = 0;
			let (change = false) {
				for each (let j in [0,1,2]) {
					let diff = Math.abs (rgb[j] - this.targetColors[ tabs[i]._agingTargetColor ][j]);
					if (diff == 0)
						continue;
					let step = 1;
					if (diff > 80 || tabs[i]._agingTargetColor + 1 < this.targetColors.length)
						step = 7;
					else if (diff > 70)
						step = 5;
					else if (diff > 65)
						step = 3;
					else if (diff > 20)
						step = 2;
					step = Math.max (1, Math.round (step * this.amount / 4));
					step = Math.min (step, diff);
					if (rgb[j] > this.targetColors[ tabs[i]._agingTargetColor ][j])
						step *= -1;
					rgb[j] = +rgb[j] + step;
					change = true;
				}
				if (change)
					this.setColor (tabs[i], rgb);
				else if (tabs[i]._agingTargetColor + 1 < this.targetColors.length)
					tabs[i]._agingTargetColor++;
			}
		}
		this.lastSelected = newSelected;
	},
	setColor : function (tab, color) {
		var nodes = document.getAnonymousNodes (tab);
		for (let i=0; i < nodes.length; i++)
			nodes[i].style.setProperty ('background-color', 'rgb('+ color[0] +', '+ color[1] +', '+ color[2] +')', '');
	},
	resetTab : function (tab) {
		var nodes = document.getAnonymousNodes (tab);
		for (let i=0; i < nodes.length; i++)
			nodes[i].style.removeProperty ('background-color');
		tab._agingTargetColor = 0;
	},
	resetAll : function() {
		var tabs = this.tabContainer.childNodes;
		for (let i=0; i < tabs.length; i++)
			this.resetTab (tabs[i]);
	},
	observe : function (subject, topic, data) {
		if (topic == 'nsPref:changed') {
			switch(data) {
				case 'agingTrigger':
				case 'agePerSeconds':
					this.getTriggerPref();
					break;
				case 'agingAmount':
					this.getAmountPref();
					break;
				case 'agingDelay':
					this.getDelayPref();
					break;
				case 'agingTargetColor':
					this.getTargetColorPref();
					this.resetAll();
					break;
				case 'color':
					this.getColorPref();
					this.getTargetColorPref();
					this.resetAll();
					break;
				case 'textColor':
					this.getTextColorPref();
					this.getTargetColorPref();
					break;
				case 'highlightActiveTab':
					this.getHighlightActiveTabPref();
					break;
				case 'highlightColor':
					this.getHighlightColorPref();
					break;
				case 'highlightTextColor':
					this.getHighlightTextColorPref();
					break;
			}
		}
	},
	getTriggerPref : function() {
		switch (this.trigger) {
			case 0:
				this.tabContainer.removeEventListener('select', this.triggerCallback, false);
				break;
			case 1:
				gURLBar.removeEventListener('ValueChange', this.triggerCallback, true);
				break;
			case 2:
				this.tabContainer.removeEventListener('select', this.triggerCallback, false);
				if (this.interval) {
					window.clearInterval (this.interval);
					this.interval = null;
				}
				break;
		}
		this.trigger = this.prefs.getIntPref('agingTrigger');
		switch (this.trigger) {
			case 0:
			case 1:
				let (obj = this) this.triggerCallback = function() {
					obj.tabSwitch (true);
				};
			case 0:
				this.tabContainer.addEventListener('select', this.triggerCallback, false);
				break;
			case 1:
				gURLBar.addEventListener('ValueChange', this.triggerCallback, true);
				break;
			case 2:
				let (obj = this) this.triggerCallback = function() {
					obj.tabSwitch (false);
				};
				this.tabContainer.addEventListener('select', this.triggerCallback, false);
				let (seconds = this.prefs.getIntPref('agePerSeconds')) {
					if (seconds > 0)
						this.interval = window.setInterval (function(obj) { obj.step() }, seconds*1000, this);
				}
				break;
		}
	},
	getAmountPref : function() {
		this.amount = this.prefs.getIntPref('agingAmount');
	},
	getDelayPref : function() {
		this.delay = this.prefs.getIntPref('agingDelay');
	},
	getTargetColorPref : function() {
		var colors = this.prefs.getCharPref('agingTargetColor').split(' ');
		this.targetColors = [];
		for (let i=0; i < colors.length; i++)
			if (/^#[\dA-F]{6}$/.test(colors[i]))
				this.targetColors.push ([
					parseInt(colors[i].substring(1,3),16),
					parseInt(colors[i].substring(3,5),16),
					parseInt(colors[i].substring(5,7),16)]);
	},
	getColorPref : function() {
		var color = this.prefs.getCharPref('color') || '-moz-dialog';
		this.defaultStyleSheet.cssRules[2].style.setProperty ('background-color', color, '');
		this.defaultStyleSheet.cssRules[3].style.setProperty ('background-color', color, 'important');
	},
	getTextColorPref : function() {
		var color = this.prefs.getCharPref('textColor') || '-moz-dialogtext';
		this.defaultStyleSheet.cssRules[4].style.setProperty ('color', color, '');
		this.defaultStyleSheet.cssRules[5].style.setProperty ('border-color', color, '');
	},
	getHighlightActiveTabPref : function() {
		this.highlightStyleSheet.disabled = !this.prefs.getBoolPref('highlightActiveTab');
	},
	getHighlightColorPref : function() {
		this.highlightStyleSheet.cssRules[2].style.setProperty ('background-color', this.prefs.getCharPref('highlightColor') || 'highlight', 'important');
	},
	getHighlightTextColorPref : function() {
		var color = this.prefs.getCharPref('highlightTextColor') || 'highlighttext';
		this.highlightStyleSheet.cssRules[3].style.setProperty ('color', color, '');
		this.highlightStyleSheet.cssRules[4].style.setProperty ('border-color', color, '');
	}
};

window.addEventListener('load', function() {
	agingTabs.init();
}, false);