function init() {
	for (let colors = ['color','textColor','highlightColor','highlightTextColor'], i=0; i < colors.length; i++) {
		let checkbox = document.getElementById('use_'+colors[i]);
		if (document.getElementById('pref_'+colors[i]).value == '')
			color2pref (colors[i]);
		else
			checkbox.checked = true;
		checkbox.setAttribute('oncommand', 'color2pref ("'+colors[i]+'")');
	}
	for (let colors = ['targetColor'], i=0; i < colors.length; i++) {
		let checkbox = document.getElementById('use_'+colors[i]);
		init_colors (colors[i]);
		if (document.getElementById('pref_'+colors[i]).value == '')
			colors2pref (colors[i]);
		else
			checkbox.checked = true;
		checkbox.setAttribute('oncommand', 'colors2pref ("'+colors[i]+'")');
	}
	let (amount = document.getElementById('amount'), amount_display = document.getElementById('amount-display'), pref_amount = document.getElementById('pref_amount')) {
		amount.setAttribute('curpos', Math.min (pref_amount.value * 5, 100));
		amount_display.setAttribute('value', pref_amount.value * 25 + '%');
		window.setInterval (function() {
			pref_amount.value = Math.round (amount.getAttribute('curpos') / 5);
			amount_display.setAttribute('value', pref_amount.value * 25 + '%');
		}, 200);
	}
}
window.addEventListener('load', init, false);

function color2pref (color) {
	var colorpicker = document.getElementById(color),
	checkbox = document.getElementById('use_'+color),
	pref = document.getElementById('pref_'+color);
	if (checkbox.checked) {
		colorpicker.style.removeProperty ('visibility');
		pref.value = colorpicker.color;
	} else {
		colorpicker.style.setProperty ('visibility', 'hidden', '');
		pref.value = '';
	}
}

function colors2pref (color) {
	var colorpickers = document.getElementById(color),
	checkbox = document.getElementById('use_'+color),
	pref = document.getElementById('pref_'+color),
	buttons = document.getElementById(color+'-buttons');
	if (checkbox.checked) {
		colorpickers.style.removeProperty ('visibility');
		buttons.style.removeProperty ('visibility');
		let color = [];
		for (let i=0; i < colorpickers.childNodes.length; i++) {
			colorpickers.childNodes[i].initialize();
			if (colorpickers.childNodes[i].color)
				color.push(colorpickers.childNodes[i].color);
		}
		pref.value = color.join(' ');
	} else {
		colorpickers.style.setProperty ('visibility', 'hidden', '');
		buttons.style.setProperty ('visibility', 'hidden', '');
		pref.value = '';
	}
}

function init_colors (color) {
	var colors = document.getElementById('pref_'+color).value.split(' ');
	for (let i=0; i < colors.length; i++)
		add_color (color, colors[i]);
}

function add_color (color, value) {
	var colorpickers = document.getElementById(color);
	if (colorpickers.childNodes.length >= 5)
		return;
	var cp = document.createElement('colorpicker');
	cp.setAttribute('type', 'button');
	cp.addEventListener('change', function(){ colors2pref (color); }, false);
	colorpickers.appendChild(cp);
	if (value) {
		cp.color = value;
		cp.initialize();
	}
}

function remove_color (color) {
	var colorpickers = document.getElementById(color);
	if (colorpickers.childNodes.length == 1)
		return;
	colorpickers.removeChild(colorpickers.lastChild);
	colors2pref(color);
}

function triggerChange() {
	document.getElementById('perSeconds').disabled = document.getElementById('trigger').value != 2;
}

function alter_amount (add) {
	var pref_amount = document.getElementById('pref_amount');
	pref_amount.value = Math.max (Math.min (pref_amount.value + add, 20), 0);
	document.getElementById('amount').setAttribute('curpos', pref_amount.value * 5);
	document.getElementById('amount-display').setAttribute('value', pref_amount.value * 25 + '%');
}